/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUTHN)

#include "JSAuthenticationExtensionsClientOutputs.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(WEB_AUTHN)

template<> AuthenticationExtensionsClientOutputs convertDictionary<AuthenticationExtensionsClientOutputs>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    AuthenticationExtensionsClientOutputs result;
    JSValue appidValue;
    if (isNullOrUndefined)
        appidValue = jsUndefined();
    else {
        appidValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "appid"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!appidValue.isUndefined()) {
        result.appid = convert<IDLBoolean>(lexicalGlobalObject, appidValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const AuthenticationExtensionsClientOutputs& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    if (!IDLBoolean::isNullValue(dictionary.appid)) {
        auto appidValue = toJS<IDLBoolean>(IDLBoolean::extractValueFromNullable(dictionary.appid));
        result->putDirect(vm, JSC::Identifier::fromString(vm, "appid"), appidValue);
    }
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(WEB_AUTHN)
